画一个顶点为偶数的封闭的二维图,当然。这个图能够自交,给出画的过程中的一些轨迹点。求出这个图把二次元分成了几部分,比如三角形把二次元分成了两部分。

这个的话,有图中顶点数+部分数-棱数=2的定律,这是核心思想。也就是所谓的欧拉定律拓扑版,好吧,事实上细致想想也是可以想出这个规律来的。

做出这题纯属意外,因为给的点的坐标全是用整数表示,为了不用考虑精度问题,一開始。我就想仅仅用这些点。就是说不再算出其他交点之类的,就把答案算出,



由于当前轨迹与之前轨迹无非三种情况:规范与不规范相交,不相交



不相交当然就不用管了,相交的话,考虑两种情况下的顶点、棱的数量变化



可是不知道是不是题意有些细节没理解到,还是有些特殊的图的情况没考虑到。用这样的思路尽管代码比較精炼。可是一直wa



后来索性干脆把全部的顶点用行列式求出,然后再求棱。略微想想能够知道,棱的数目是在轨迹数目的基础上加上在轨迹中间,即在轨迹上。不在轨迹两点的交点数目



这里就须要通过叉积推断点是否在轨迹中间。因为题中没有给出精度要求……假设不给一个精度,而直接用叉积为0推断点是否在轨迹所在的直线上的话,会wa



由于直接用0。相当于。精度就是double的精度,也就是1e-15,所以后来改成了1e-9然后就过了。



须要注意的是,在杭电上也有相同的题,但明显杭电的oj比UVA的渣,杭电的g++比c++的精度运算损失少,所以在杭电上交用这样的不太好的方法写的代码,须要用g++交才干



过。

我的代码:

#include<iostream>
#include<map>
#include<string>
#include<cstring>
#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<queue>
#include<vector>
#include<algorithm>
using namespace std;
const double inf=1e4,eps=1e-9;
struct dot
{
double x,y;
dot(){}
dot(double a,double b){x=a;y=b;}
dot operator -(dot a){return dot(x-a.x,y-a.y);}
friend bool operator <(dot a,dot b){return a.x!=b.x?a.x<b.x:a.y<b.y;}
bool operator ==(dot a){return x==a.x&&y==a.y;}
bool operator !=(dot a){return x!=a.x||y!=a.y;}
double operator *(dot a){return x*a.y-y*a.x;}
double dis(dot a){return sqrt(pow(x-a.x,2)+pow(y-a.y,2));}
};
bool isdil(dot a,dot b,dot c)
{
return a.x<=max(b.x,c.x)&&
a.y<=max(b.y,c.y)&&
min(b.x,c.x)<=a.x&&
min(b.y,c.y)<=a.y&&
a!=b&&a!=c;
}
bool isdbl(dot a,dot b,dot c){return fabs((a-c)*(b-c))<eps&&isdil(a,b,c);}
dot cross(dot a,dot b,dot c,dot d)
{
double e,f,g,h,i,j,k,l,m;
e=b.y-a.y;f=a.x-b.x;g=a.x*b.y-a.y*b.x;
h=d.y-c.y;i=c.x-d.x;j=c.x*d.y-c.y*d.x;
k=dot(e,h)*dot(f,i);
if(k==0)
return dot(inf,inf);
l=dot(g,j)*dot(f,i);
m=dot(e,h)*dot(g,j);
dot t=dot(l/k,m/k);
return isdil(t,a,b)&&isdil(t,c,d)?t:dot(inf,inf);
}
int main()
{
dot a[310],b[30000],t;
int i,n,j,k,ans,T=0;
while(cin>>n&&n)
{
for(i=0;i<n;i++)
{
cin>>a[i].x>>a[i].y;
b[i]=a[i];
}
k=n;
for(i=1;i<n;i++)
for(j=i+2;j<n;j++)
{
t=cross(a[i-1],a[i],b[j-1],b[j]);
if(t.x!=inf)
b[k++]=t;
}
sort(b,b+k);
k=unique(b,b+k)-b;
ans=1+n-k;
for(j=0;j<k;j++)
for(i=1;i<n;i++)
if(isdbl(b[j],a[i-1],a[i]))
ans++;
printf("Case %d: There are %d pieces.\n",++T,ans);
}
}

原题:

Description

Little Joey invented a scrabble machine that he called Euler, after the great mathematician. In his primary school Joey heard about the nice story of how Euler started the study about graphs. The problem in that story was - let me remind you - to draw a
graph on a paper without lifting your pen, and finally return to the original position. Euler proved that you could do this if and only if the (planar) graph you created has the following two properties: (1) The graph is connected; and (2) Every vertex in
the graph has even degree.

Joey's Euler machine works exactly like this. The device consists of a pencil touching the paper, and a control center issuing a sequence of instructions. The paper can be viewed as the infinite two-dimensional plane; that means you do not need to worry about
if the pencil will ever go off the boundary.

In the beginning, the Euler machine will issue an instruction of the form
(X0, Y0) which moves the pencil to some starting position(X0,Y0). Each subsequent instruction is also of the form(X',Y'), which means to move the
pencil from the previous position to the new position(X',Y'), thus draw a line segment on the paper. You can be sure that the new position is different from the previous position for each instruction. At last, the
Euler machine will always issue an instruction that move the pencil back to the starting position(X0,
Y0). In addition, the Euler machine will definitely not draw any lines that overlay other lines already drawn. However, the lines may intersect.

After all the instructions are issued, there will be a nice picture on Joey's paper. You see, since the pencil is never lifted from the paper, the picture can be viewed as an Euler circuit.

Your job is to count how many pieces (connected areas) are created on the paper by those lines drawn by Euler.

Input

There are no more than 25 test cases. Ease case starts with a line containing an integerN4,
which is the number of instructions in the test case. The followingN pairs of integers give the instructions and appear on a single line separated by single spaces. The first pair is the first instruction that gives the coordinates
of the starting position. You may assume there are no more than 300 instructions in each test case, and all the integer coordinates are in the range (-300, 300). The input is terminated whenN is 0.

Output

For each test case there will be one output line in the format

Case x: There are w pieces.,

where x is the serial number starting from 1.

Note: The figures below illustrate the two sample input cases.

Sample Input

5
0 0 0 1 1 1 1 0 0 0
7
1 1 1 5 2 1 2 5 5 1 3 5 1 1
0

Sample Output

Case 1: There are 2 pieces.
Case 2: There are 5 pieces.

UVA LIVE-3263 - That Nice Euler Circuit的更多相关文章

  1. UVALive - 3263 That Nice Euler Circuit (几何)

    UVALive - 3263 That Nice Euler Circuit (几何) ACM 题目地址:  UVALive - 3263 That Nice Euler Circuit 题意:  给 ...

  2. UVALi 3263 That Nice Euler Circuit(几何)

    That Nice Euler Circuit [题目链接]That Nice Euler Circuit [题目类型]几何 &题解: 蓝书P260 要用欧拉定理:V+F=E+2 V是顶点数; ...

  3. LA 3263 That Nice Euler Circuit(欧拉定理)

    That Nice Euler Circuit Little Joey invented a scrabble machine that he called Euler, after the grea ...

  4. 简单几何(求划分区域) LA 3263 That Nice Euler Circuit

    题目传送门 题意:一笔画,问该图形将平面分成多少个区域 分析:训练指南P260,欧拉定理:平面图定点数V,边数E,面数F,则V + F - E =  2.那么找出新增的点和边就可以了.用到了判断线段相 ...

  5. uvalive 3263 That Nice Euler Circuit

    题意:平面上有一个包含n个端点的一笔画,第n个端点总是和第一个端点重合,因此团史一条闭合曲线.组成一笔画的线段可以相交,但是不会部分重叠.求这些线段将平面分成多少部分(包括封闭区域和无限大区域). 分 ...

  6. UVAlive 3263 That Nice Euler Circuit(欧拉定理)

    题目链接:http://acm.hust.edu.cn/vjudge/problem/viewProblem.action?id=21363 [思路] 欧拉定理:V+F-E=2.则F=E-V+2. 其 ...

  7. UVALive 3263: That Nice Euler Circuit (计算几何)

    题目链接 lrj训练指南 P260 //==================================================================== // 此题只需要考虑线 ...

  8. UVa 10735 - Euler Circuit(最大流 + 欧拉回路)

    链接: https://uva.onlinejudge.org/index.php?option=com_onlinejudge&Itemid=8&page=show_problem& ...

  9. UVa 10735 (混合图的欧拉回路) Euler Circuit

    题意: 给出一个图,有的边是有向边,有的是无向边.试找出一条欧拉回路. 分析: 按照往常的思维,遇到混合图,我们一般会把无向边拆成两条方向相反的有向边. 但是在这里却行不通了,因为拆成两条有向边的话, ...

随机推荐

  1. java 二叉树遍历

    package com.lever; import java.util.LinkedList;import java.util.Queue; /** * 二叉树遍历 * @author lckxxy ...

  2. Android Studio配置opencv

    安装过程参考:http://www.cnblogs.com/tail/p/4618476.html demo参考:http://blog.csdn.net/gao_chun/article/detai ...

  3. 网络协议之TCP

    前言 近年来,随着信息技术的不断发展,各行各业也掀起了信息化浪潮,为了留住用户和吸引用户,各个企业力求为用户提供更好的信息服务,这也导致WEB性能优化成为了一个热点.据分析,网站速度越快,用户的黏性. ...

  4. NOIP2015&2016普及组解题报告

    NOIP2015普及组题目下载 NOIP2016普及组题目下载 NOIP2015普及组题目: NOIP2018RP++ NOIP2016普及组题目 NOIP2018RP++ T1 金币\((coin. ...

  5. C#基础之数据类型

    c#有15个预定义类型,其中13个是值类型,两个是引用类型(string 和 object) 1.整型 2.浮点类型 float数据类型用于较小的浮点数,因为它要求的精度较低. double数据类型比 ...

  6. 转:40个Java集合面试问题和答案

    转自牛客网:http://mp.weixin.qq.com/s?__biz=MjM5NDYxMzk1Nw==&mid=215319390&idx=1&sn=1ab621bc40 ...

  7. CodeIgniter2.0中sqlserver驱动返回受影响行数问题解决

    最近使用CI写项目时遇到的问题,当使用sqlserve链接操作时 修改和删除返回的受影响行数不对 解决办法如下: 找到ci框架目录中include\database\drivers\sqlsrv\sq ...

  8. 自己封装的php Curl并发处理,欢迎提出问题优化。

    因为项目需要,发现一个一个发送请求实在太慢,无奈之下,我们可以封装一个并发处理的curl请求批处理句柄来减少重复创建句柄的问题 代码如下: /* *@param array $data url的参数 ...

  9. mongodb导入导出

    导出 mongoexport -d 数据库 -c 表名 -o 输出文件名 例:mongoexport -d Mongodb_DataManager -c Kujiale_Users -o Kujial ...

  10. 【LOJ】#2244. 「NOI2014」起床困难综合症

    题解 写水题放松一下心情 二进制有个很好的性质是每一位是独立的,我们按位贪心,先看这一位能不能填1,然后看看如果这一位填0那么运算后最后这一位是不是1,是的话就退出,然后看看这一位如果填1最后是1这一 ...